#pragma once

#ifdef __cplusplus
extern "C" {
#endif

#include <inttypes.h>

enum {
    HARDWARE_TASK_IDLE = 0,
    HARDWARE_TASK_RUNNING = 1,
    HARDWARE_TASK_DONE = 2
};

void hardware_task_start( uint32_t base );

uint32_t hardware_task_get_state( uint32_t base );

uint32_t hardware_task_get_cycle_count( uint32_t base );

void hardware_task_set_config( uint32_t base, uint32_t offset, uint32_t value );
uint32_t hardware_task_get_config( uint32_t base, uint32_t offset );

#ifdef __cplusplus
}
#endif

